//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "RunningFrame0.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
int upX=0, dnX=0, ltY=0, rtY=0;
int skip=5, shift=1, len=12;
int ds= len + skip;

void runningLineX(TCanvas *canvas, int x, int y, int& start, int width, bool firstTime=false)
{ int sx;
  canvas->Pen->Mode = pmNot;
  if ( start>skip )
    { canvas->MoveTo(x,    y);
      canvas->LineTo(x+start-skip, y);
    }
  for (sx=start; sx<width-ds; sx+=ds)
     { canvas->MoveTo(x+sx,    y);
       canvas->LineTo(x+sx+len, y);
     }
  if ( sx<width-len )
    { canvas->MoveTo(x+sx,    y);
      canvas->LineTo(x+sx+len, y);
    }
  else
    { canvas->MoveTo(x+sx,    y);
      canvas->LineTo(x+width, y);
    }
  if ( firstTime )  return;
  start = (start + shift) % (ds);
  if ( start>skip )
    { canvas->MoveTo(x,    y);
      canvas->LineTo(x+start-skip, y);
    }
  for (sx=start; sx<width-ds; sx+=ds)
     { canvas->MoveTo(x+sx,    y);
       canvas->LineTo(x+sx+len, y);
     }
  if ( sx<width-len )
    { canvas->MoveTo(x+sx,    y);
      canvas->LineTo(x+sx+len, y);
    }
  else
    { canvas->MoveTo(x+sx,    y);
      canvas->LineTo(x+width, y);
    }
  canvas->Pen->Mode = pmCopy;
}
void runningLineY(TCanvas *canvas, int x, int y, int& start, int width, bool firstTime=false)
{ int sy;
  canvas->Pen->Mode = pmNot;
  if ( start>skip )
    { canvas->MoveTo(x,    y);
      canvas->LineTo(x, y+start-skip);
    }
  for (sy=start; sy<width-ds; sy+=ds)
     { canvas->MoveTo(x, y+sy);
       canvas->LineTo(x, y+sy+len);
     }
  if ( sy<width-len )
    { canvas->MoveTo(x, y+sy);
      canvas->LineTo(x, y+sy+len);
    }
  else
    { canvas->MoveTo(x, y+sy);
      canvas->LineTo(x, y+width);
    }
  if ( firstTime )  return;
  start = (start + shift) % (ds);
  if ( start>skip )
    { canvas->MoveTo(x,    y);
      canvas->LineTo(x, y+start-skip);
    }
  for (sy=start; sy<width-ds; sy+=ds)
     { canvas->MoveTo(x, y+sy);
       canvas->LineTo(x, y+sy+len);
     }
  if ( sy<width-len )
    { canvas->MoveTo(x, y+sy);
      canvas->LineTo(x, y+sy+len);
    }
  else
    { canvas->MoveTo(x, y+sy);
      canvas->LineTo(x, y+width);
    }
  canvas->Pen->Mode = pmCopy;
}

int sftX=10, sftY=10;

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  runningLineX(Form1->Canvas, sftX, sftY, upX, Image1->Width);
  runningLineX(Form1->Canvas, sftX, sftY+Image1->Height-1, dnX, Image1->Width);
  runningLineY(Form1->Canvas, sftX, sftY, ltY, Image1->Height);
  runningLineY(Form1->Canvas, sftX+Image1->Width-1, sftY, rtY, Image1->Height);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  Form1->Canvas->Draw(sftX,sftY,Image1->Picture->Graphic);

  runningLineX(Form1->Canvas, sftX, sftY, upX, Image1->Width, true);
  runningLineX(Form1->Canvas, sftX, sftY+Image1->Height-1, dnX, Image1->Width, true);
  runningLineY(Form1->Canvas, sftX, sftY, ltY, Image1->Height, true);
  runningLineY(Form1->Canvas, sftX+Image1->Width-1, sftY, rtY, Image1->Height, true);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::bbtnRunningClick(TObject *Sender)
{
  Timer1->Enabled = ! Timer1->Enabled;
  if ( Timer1->Enabled )
    bbtnRunning->Caption = "Stop Running";
  else
    bbtnRunning->Caption = "Start Running";
}
//---------------------------------------------------------------------------
int prevX, prevY;
bool drawing = false;

void __fastcall TForm1::grpFunctionMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  drawing = true;
  prevX = X;
  prevY = Y;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::grpFunctionMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  if ( drawing )
    { int dx = X - prevX;
      int dy = Y - prevY;
      grpFunction->Left += dx;
      grpFunction->Top  += dy;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::grpFunctionMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  drawing = false;
}
//---------------------------------------------------------------------------
